// main.c
// Main C file for the flash driver
#include <board.h>		//place components into prog_mem_MP0/SRAM-0Ba/text
#include <type.h>
/*#include <codec.h>
#include <mcbsp54.h>*/

typedef unsigned int	word;
#define		SWWSR	(*((volatile word*)0x0028))


/*****************************************************************************/
/* Global Variables                                                          */
/*****************************************************************************/
/*HANDLE hHandset;
s16 data[];
static short counter = 0;*/
static short i = 0;
//static short sample_var;

extern int bio_test()
{
asm("_test_bio:");
asm("	LD #0, A ;Set return value to false ");
asm("	BC bio_low, NBIO ;BIO = high");
asm("	;BIO = 0 => moving forward");
asm("	NOP");
asm("	NOP ");
asm("	LD #1, A ;Set return value to true ");
asm("	RET ;Card present, return normally");
asm("bio_low: ;bio is low ");
asm("	RET ;exit");
}

void setup_interrupt()
{
	asm(" SSBX INTM");	// Globally disable interrupts
	asm(" STM #1,1h");	// Clear any previous interrupt
	asm(" STM #1,0h");	// Enable the int0 interrupt
	asm(" RSBX INTM");	// Globally enable interrupts
}

void main()
{
	// Setup the number of wait states for the board
	SWWSR = 0xD884;	
	
	// Setup the interrupt handler
	setup_interrupt();

	// Finally, go into a loop to allow the interrupt to execute
	while(1);
}


/************************************************************************************
-------------------- SI_interrupt ---------------------------------------------------
1. record the CCD output (57 samples after SI pulse)
2. determine dots within image slice of 57 samples
3. store then correlate with previous or latter slices constituting a braille cell
4. determine braille cell
5. send to host(use rtdx, does not require dsp/bios)
*************************************************************************************/
interrupt void SI_interrupt0()
{
	static short codewheel_var;
	
	
codewheel_var = 0;		//reset codewheel_var, is set every time X_INT0 occurs, ie every 5.3 mS
brd_led_toggle(BRD_LED2);
i = bio_test();
if (i == 1) { brd_led_enable(BRD_LED0); 
			  	brd_led_enable(BRD_LED1);}
if (i == 0)	{ brd_led_disable(BRD_LED0); 
			  		brd_led_disable(BRD_LED1);}
asm("	SSBX 1, 13");
				
	asm("	STM #0000000000000001b,IFR");	// Clear the interrupt, ie IFR = 0x01;
//----------------------- 1. record the CCD output (57 samples after SI pulse)--------------	
/*for (sample_var = 0; sample_var != 57; ++sample_var)  { 
		   // Wait for sample from handset 
       while (!MCBSP_RRDY(HANDSET_CODEC)) {};

       // Read sample from handset codec 
       data[sample_var] = *(volatile u16*)DRR1_ADDR(HANDSET_CODEC);
			}*/
/*--------------------2. determine dots within image slice of 57 samples--------------------
  a. use at least 3 image slices to detemine dots in a "slice', since ccd
 	 may not be perfectly horizontal
  b. for every 5 or so ccd samples (breaking image slice into about 10 parts), check
  	 to see if a dot exists. Since the distance between dots is precisely known and
  	 constant from the first dot found, corresponding area's where the dots could be 
  	 found are checked. Therefore the actual place of the first dot can vary and proper
  	 braille cell type can still be determined*/

/*-----3. store then correlate with previous or latter slices constituting a braille cell---
	- Since initially the ccd could be placed anywhere on the braille line, the first image 
	slice will only be used if the next image slice contituting dots is inside the width
	of a braille cell (determined by counting the codewheel interrupts) otherwise it is
	discarded (as being the the second row of a braille cell)
	*/
//-------------------------------4. determine braille cell---------------------------------
/*-----------------------------5. send to host(use rtdx, does not require dsp/bios)-------*/
			

}

/**************************************************************************************
---------------------- codewheel_interrupt --------------------------------------------
The SI Pulse provides an interrupt to X_INT0 every 5.3 mS, 
the DSP will then only process the CCD image slice from the AIC if 
a X_INT1 event (indicating a codewheel trigger signal) 
occurred in the last 5.3 mS AND XF equals zero (indicating forward motion)
***************************************************************************************/
interrupt void codewheel_interrupt1()
{
/*if (codewheel_var == 1) {
	brd_led_toggle(BRD_LED0); //"going too fast", codewheel has sent two interrupts before
	 						  //ccd/dsp has had time to process first
	  }
			
if ((BIO == 0) && (codewheel_var == 0) {  //ie scanner is moving slowly forward
	codewheel_var = 1;		  	//codewheel trigger interrupt has occurred
	}*/
//direction of scan test

}
