/*#############################################################################
## $Id: $
##
###############################################################################
##      Copyright (c) 1999 DNA Enterprises, Inc.
###############################################################################
## Revision History
## ----------------
##  $Log: $
##
###############################################################################
###############################################################################
## XFERMAKE.CMD
## ------------
## C54x Linker Command File for 5402 DSK Memory Transfer Module
##
#############################################################################*/

/*****************************************************************************/
/* Object Files                                                              */
/*****************************************************************************/


/*****************************************************************************/
/* Linker Options                                                            */
/*****************************************************************************/


/*****************************************************************************/
/* C5402 DSK DSP Memory Map                                                  */
/*                                                                           */
/*****************************************************************************/

MEMORY
{
   PAGE 0: VECS:     origin = 0C000h, length = 0080h  /* Internal Program RAM */
           PRAM:     origin = 8000h, length = 4000h  /* Internal Program RAM */

   PAGE 1: SCRATCH:  origin = 0060h, length = 0020h  /* Scratch Pad Data RAM */
           DATA:     origin = 3000h, length = 0080h  /* Internal Data RAM    */
           STACK:    origin = 3100h, length = 0500h  /* Stack Memory Space   */
           EXRAM:    origin = 3600h, length = 0900h  /* External Data RAM    */
}

/*****************************************************************************/
/* DSP Memory Allocation                                                     */
/*****************************************************************************/

SECTIONS
{
   .cinit    > PRAM  PAGE 0
   .text     > PRAM  PAGE 0
   .vectors  > VECS  PAGE 0
    
   .stack    > STACK PAGE 1
   .trap     > SCRATCH PAGE 1

   .const    > EXRAM PAGE 1
   .data     > EXRAM PAGE 1
   .bss      > EXRAM PAGE 1
   .cio      > EXRAM PAGE 1

   .switch   > EXRAM PAGE 1
}