;***************************************************************
;* TMS320C54x ANSI C Codegen                      Version 3.70 *
;* Date/Time created: Thu Aug 01 16:44:51 2002                 *
;***************************************************************
	.mmregs
FP	.set	AR7
	.c_mode
	.file	"main.c"
	.global	_hHandset
	.bss	_hHandset,1,0,0
	.sym	_hHandset,_hHandset, 16, 2, 16
	.global	_data
	.bss	_data,1,0,0
	.sym	_data,_data, 52, 2, 16,, 1

	.sect	".cinit"
	.align	1
	.field  	1,16
	.field  	_i+0,16
	.field  	0,16			; _i @ 0
	.sect	".text"
	.bss	_i,1,0,0
	.sym	_i,_i, 3, 3, 16
	.bss	_sample_var,1,0,0
	.sym	_sample_var,_sample_var, 3, 3, 16
	.bss	_codewheel_var$1,1,0,0
	.sym	_codewheel_var,_codewheel_var$1, 3, 3, 16
;	c:\ti\c5400\cgtools\bin\acp500.exe -q -@C:\Documents and Settings\pasco\Local Settings\Temp\TI1508_4 
	.sect	".text"
	.global	_bio_test
	.sym	_bio_test,_bio_test, 36, 2, 0
	.func	24

;***************************************************************
;* FUNCTION DEF: _bio_test                                     *
;***************************************************************
_bio_test:
	.line	2
	.line	3
_test_bio:
	.line	4
	LD #0, A ;Set return value to false 
	.line	5
	BC bio_low, NBIO ;BIO = high
	.line	6
	;BIO = 0 => moving forward
	.line	7
	NOP
	.line	8
	NOP 
	.line	9
	LD #1, A ;Set return value to true 
	.line	10
	RET ;Card present, return normally
	.line	11
bio_low: ;bio is low 
	.line	12
	RET ;exit
	.line	13
        RET
        ; return occurs
	.endfunc	36,000000000h,0


	.sect	".text"
	.global	_setup_interrupt
	.sym	_setup_interrupt,_setup_interrupt, 32, 2, 0
	.func	38

;***************************************************************
;* FUNCTION DEF: _setup_interrupt                              *
;***************************************************************
_setup_interrupt:
	.line	2
	.line	3
 SSBX INTM
	.line	4
 STM #1,1h
	.line	5
 STM #1,0h
	.line	6
 RSBX INTM
	.line	7
        RET
        ; return occurs
	.endfunc	44,000000000h,0


	.sect	".text"
	.global	_main
	.sym	_main,_main, 32, 2, 0
	.func	53

;***************************************************************
;* FUNCTION DEF: _main                                         *
;***************************************************************
_main:
	.line	2
        FRAME     #-3
	.line	4
	STM #1101100010000100b,SWWSR
	.line	5
	RSBX 1, 13
	.line	8
        CALL      #_setup_interrupt     ; |60| 
        ; call occurs [#_setup_interrupt] ; |60| 
	.line	14
        CALLD     #_codec_open          ; |66| 
        NOP
        LD        #1,A
        ; call occurs [#_codec_open] ; |66| 
        STL       A,*(_hHandset)
	.line	17
        ST        #1,*SP(0)             ; |69| 
        CALL      #_codec_adc_mode      ; |69| 
        ; call occurs [#_codec_adc_mode] ; |69| 
	.line	18
        ST        #0,*SP(0)             ; |70| 
        LD        *(_hHandset),A
        CALL      #_codec_ain_gain      ; |70| 
        ; call occurs [#_codec_ain_gain] ; |70| 
	.line	19
        LD        *(_hHandset),A
        ST        #144,*SP(0)           ; |71| 
        CALL      #_codec_sample_rate   ; |71| 
        ; call occurs [#_codec_sample_rate] ; |71| 
	.line	24
L1:    
        B         L1                    ; |76| 
        ; branch occurs ; |76| 
	.endfunc	83,000000000h,3


	.sect	".text"
	.global	_SI_interrupt0
	.sym	_SI_interrupt0,_SI_interrupt0, 32, 2, 0
	.func	94

;***************************************************************
;* FUNCTION DEF: _SI_interrupt0                                *
;***************************************************************
_SI_interrupt0:
	.line	2
        NOP
        PSHM      AL
        PSHM      AH
        PSHM      AG
        PSHM      BL
        PSHM      BH
        PSHM      BG
        PSHM      AR0
        PSHM      AR1
        PSHM      AR2
        PSHM      AR3
        PSHM      AR4
        PSHM      AR5
        PSHM      AR6
        PSHM      AR7
        PSHM      FP
        PSHM      BK
        PSHM      T
        PSHM      ST0
        PSHM      ST1
        PSHM      BRC
        PSHM      PMST
        PSHM      RSA
        PSHM      REA
        ANDM      #32063,*(ST1)
        ORM       #16384,*(ST1)
        ANDM      #-4,*(PMST)
        LDM       SP,A
        ANDM      #-2,*(SP)
        NOP
        NOP
        PSHM      AL
        FRAME     #-1
	.line	6
        ST        #0,*(_codewheel_var$1) ; |99| 
	.line	7
        CALLD     #_brd_led_toggle      ; |100| 
        NOP
        LD        #2,A
        ; call occurs [#_brd_led_toggle] ; |100| 
	.line	8
        CALL      #_bio_test            ; |101| 
        ; call occurs [#_bio_test] ; |101| 
        STL       A,*(_i)
	.line	9
        CMPM      *(_i),#1              ; |102| 
        BC        L2,NTC                ; |102| 
        ; branch occurs ; |102| 
        CALLD     #_brd_led_enable      ; |102| 
        NOP
        LD        #0,A
        ; call occurs [#_brd_led_enable] ; |102| 
	.line	10
        CALLD     #_brd_led_enable      ; |103| 
        NOP
        LD        #1,A
        ; call occurs [#_brd_led_enable] ; |103| 
L2:    
	.line	11
        LD        *(_i),A               ; |104| 
        BC        L3,ANEQ               ; |104| 
        ; branch occurs ; |104| 
        CALLD     #_brd_led_disable     ; |104| 
        NOP
        LD        #0,A
        ; call occurs [#_brd_led_disable] ; |104| 
	.line	12
        CALLD     #_brd_led_disable     ; |105| 
        NOP
        LD        #1,A
        ; call occurs [#_brd_led_disable] ; |105| 
L3:    
	.line	13
	SSBX 1, 13
	.line	15
	STM #0000000000000001b,IFR
	.line	17
        ST        #0,*(_sample_var)     ; |110| 
        CMPM      *(_sample_var),#57    ; |110| 
        BC        L5,TC                 ; |110| 
        ; branch occurs ; |110| 
	.line	19
L4:    
        STM       #72,AR1
        ST        #0,*AR1               ; |112| 
        LD        #2,A
        STM       #73,AR1
        LDU       *AR1,B
        AND       B,A                   ; |112| 
        SFTL      A,#-1,A
        NOP
        LDM       AL,A                  ; |112| 
        BC        L4,AEQ                ; |112| 
        ; branch occurs ; |112| 
	.line	22
        STM       #65,AR1
        LD        *AR1,A
        MVDM      *(_sample_var),AR1
        NOP
        STL       A,*AR1(_data)
	.line	23
        ADDM      #1,*(_sample_var)     ; |116| 
        CMPM      *(_sample_var),#57    ; |116| 
        BC        L4,NTC                ; |116| 
        ; branch occurs ; |116| 
L5:    
	.line	43
        FRAME     #1
        POPM      SP
        NOP
        POPM      REA
        POPM      RSA
        POPM      PMST
        POPM      BRC
        POPM      ST1
        POPM      ST0
        POPM      T
        POPM      BK
        POPM      FP
        POPM      AR7
        POPM      AR6
        POPM      AR5
        POPM      AR4
        POPM      AR3
        POPM      AR2
        POPM      AR1
        POPM      AR0
        POPM      BG
        POPM      BH
        POPM      BL
        POPM      AG
        POPM      AH
        POPM      AL
        RETE
        ; branch occurs
	.endfunc	136,0e39dffc7h,23


	.sect	".text"
	.global	_codewheel_interrupt1
	.sym	_codewheel_interrupt1,_codewheel_interrupt1, 32, 2, 0
	.func	145

;***************************************************************
;* FUNCTION DEF: _codewheel_interrupt1                         *
;***************************************************************
_codewheel_interrupt1:
	.line	2
        PSHM      ST1
        PSHM      PMST
        ANDM      #32063,*(ST1)
        ORM       #16384,*(ST1)
        ANDM      #-4,*(PMST)
        NOP
	.line	13
        POPM      PMST
        POPM      ST1
        RETE
        ; branch occurs
	.endfunc	157,021000000h,2


;***************************************************************
;* UNDEFINED EXTERNAL REFERENCES                               *
;***************************************************************
	.global	_brd_led_enable
	.global	_brd_led_disable
	.global	_brd_led_toggle
	.global	_codec_open
	.global	_codec_adc_mode
	.global	_codec_ain_gain
	.global	_codec_sample_rate

;***************************************************************
;* TYPE INFORMATION                                            *
;***************************************************************
	.sym	_s16, 0, 4, 13, 16
	.sym	_s16, 0, 4, 13, 16
	.sym	_u16, 0, 14, 13, 16
	.sym	_u16, 0, 14, 13, 16
	.sym	_u16, 0, 14, 13, 16
	.sym	_HANDLE, 0, 16, 13, 16
	.etag	$$fake0, 16
	.member	_BRD_LED0, 0, 4, 16, 16
	.member	_BRD_LED1, 1, 4, 16, 16
	.member	_BRD_LED2, 2, 4, 16, 16
	.eos
	.sym	_BrdLed, 0, 10, 13, 16,$$fake0
	.etag	$$fake2, 16
	.member	_CODEC_ADC_16BIT, 0, 4, 16, 16
	.member	_CODEC_ADC_15BIT, 1, 4, 16, 16
	.eos
	.sym	_CodecAdcMode, 0, 10, 13, 16,$$fake2
	.etag	$$fake3, 16
	.member	_CODEC_AIN_MUTE, 3, 4, 16, 16
	.member	_CODEC_AIN_12dB, 2, 4, 16, 16
	.member	_CODEC_AIN_6dB, 1, 4, 16, 16
	.member	_CODEC_AIN_0dB, 0, 4, 16, 16
	.eos
	.sym	_CodecAinGain, 0, 10, 13, 16,$$fake3
	.etag	$$fake4, 16
	.member	_SR_2000, 128, 4, 16, 16
	.member	_SR_2285, 240, 4, 16, 16
	.member	_SR_2667, 224, 4, 16, 16
	.member	_SR_3200, 208, 4, 16, 16
	.member	_SR_4000, 192, 4, 16, 16
	.member	_SR_5333, 176, 4, 16, 16
	.member	_SR_8000, 160, 4, 16, 16
	.member	_SR_9142, 112, 4, 16, 16
	.member	_SR_10667, 96, 4, 16, 16
	.member	_SR_12800, 80, 4, 16, 16
	.member	_SR_16000, 144, 4, 16, 16
	.eos
	.sym	_CodecSampleRate, 0, 10, 13, 16,$$fake4
	.etag	$$fake1, 16
	.member	_DAA_CODEC, 0, 4, 16, 16
	.member	_HANDSET_CODEC, 1, 4, 16, 16
	.member	_SLIC_CODEC, 2, 4, 16, 16
	.eos
	.sym	_CodecId, 0, 10, 13, 16,$$fake1
