;***************************************************************
;* TMS320C54x ANSI C Codegen                      Version 3.70 *
;* Date/Time created: Tue Aug 06 14:15:40 2002                 *
;***************************************************************
	.mmregs
FP	.set	AR7
	.c_mode
	.file	"main.c"

	.sect	".cinit"
	.align	1
	.field  	1,16
	.field  	_codewheel_var+0,16
	.field  	0,16			; _codewheel_var @ 0
	.sect	".text"
	.bss	_codewheel_var,1,0,0
	.sym	_codewheel_var,_codewheel_var, 3, 3, 16
;	c:\ti\c5400\cgtools\bin\acp500.exe -q -@C:\Documents and Settings\pasco\Local Settings\Temp\TI1784_4 
	.sect	".text"
	.global	_bio_test
	.sym	_bio_test,_bio_test, 36, 2, 0
	.func	26

;***************************************************************
;* FUNCTION DEF: _bio_test                                     *
;***************************************************************
_bio_test:
	.line	2
	.line	3
_test_bio:
	.line	4
	LD #0, A ;Set return value to false 
	.line	5
	BC bio_low, NBIO ;NBIO = high
	.line	6
	;BIO = 0 => moving forward
	.line	7
	NOP
	.line	8
	NOP 
	.line	9
	LD #1, A ;Set return value to true 
	.line	10
	RET ;Card present, return normally
	.line	11
bio_low: ;bio is low 
	.line	12
	RET ;exit
	.line	13
        RET
        ; return occurs
	.endfunc	38,000000000h,0


	.sect	".text"
	.global	_setup_interrupt
	.sym	_setup_interrupt,_setup_interrupt, 32, 2, 0
	.func	40

;***************************************************************
;* FUNCTION DEF: _setup_interrupt                              *
;***************************************************************
_setup_interrupt:
	.line	2
	.line	3
 SSBX INTM
	.line	4
 STM #5,1h
	.line	5
 STM #5,0h
	.line	6
 RSBX INTM
	.line	7
        RET
        ; return occurs
	.endfunc	46,000000000h,0


	.sect	".text"
	.global	_main
	.sym	_main,_main, 32, 2, 0
	.func	56

;***************************************************************
;* FUNCTION DEF: _main                                         *
;***************************************************************
_main:
	.line	2
        PSHM      AR1
	.line	4
        STM       #40,AR1
        ST        #55428,*AR1           ; |59| 
	.line	5
	RSBX 1, 13
	.line	9
        CALL      #_setup_interrupt     ; |64| 
        ; call occurs [#_setup_interrupt] ; |64| 
	.line	10
        LD        #128,A
        PORTW     *(AL),00H             ; |65| 
	.line	24
L1:    
        B         L1                    ; |79| 
        ; branch occurs ; |79| 
	.endfunc	81,000000400h,1


	.sect	".text"
	.global	_codewheel_interrupt0
	.sym	_codewheel_interrupt0,_codewheel_interrupt0, 32, 2, 0
	.func	91

;***************************************************************
;* FUNCTION DEF: _codewheel_interrupt0                         *
;***************************************************************
_codewheel_interrupt0:
	.line	2
        NOP
        PSHM      AL
        PSHM      AH
        PSHM      AG
        PSHM      BL
        PSHM      BH
        PSHM      BG
        PSHM      AR0
        PSHM      AR1
        PSHM      AR2
        PSHM      AR3
        PSHM      AR4
        PSHM      AR5
        PSHM      AR6
        PSHM      AR7
        PSHM      FP
        PSHM      BK
        PSHM      T
        PSHM      ST0
        PSHM      ST1
        PSHM      BRC
        PSHM      PMST
        PSHM      RSA
        PSHM      REA
        ANDM      #32063,*(ST1)
        ORM       #16384,*(ST1)
        ANDM      #-4,*(PMST)
        LDM       SP,A
        ANDM      #-2,*(SP)
        NOP
        NOP
        PSHM      AL
        FRAME     #-1
	.line	3
 SSBX INTM
	.line	6
        CALL      #_bio_test            ; |96| 
        ; call occurs [#_bio_test] ; |96| 
        STL       A,*(_codewheel_var)
	.line	7
        CMPM      *(_codewheel_var),#1  ; |97| 
        BC        L2,NTC                ; |97| 
        ; branch occurs ; |97| 
	.line	8
        CALLD     #_brd_led_enable      ; |98| 
        NOP
        LD        #0,A
        ; call occurs [#_brd_led_enable] ; |98| 
	.line	9
        CALLD     #_brd_led_enable      ; |99| 
        NOP
        LD        #1,A
        ; call occurs [#_brd_led_enable] ; |99| 
	.line	10
	SSBX 1, 13
	.line	11
	STM #1h,IFR
	.line	12
 	STM #4h,0h
L2:    
	.line	15
        LD        *(_codewheel_var),A   ; |105| 
        BC        L3,ANEQ               ; |105| 
        ; branch occurs ; |105| 
	.line	16
        CALLD     #_brd_led_disable     ; |106| 
        NOP
        LD        #0,A
        ; call occurs [#_brd_led_disable] ; |106| 
	.line	17
        CALLD     #_brd_led_disable     ; |107| 
        NOP
        LD        #1,A
        ; call occurs [#_brd_led_disable] ; |107| 
	.line	18
        CALLD     #_brd_led_disable     ; |108| 
        NOP
        LD        #2,A
        ; call occurs [#_brd_led_disable] ; |108| 
L3:    
	.line	20
 STM #5,1h
	.line	21
 RSBX INTM
	.line	23
        FRAME     #1
        POPM      SP
        NOP
        POPM      REA
        POPM      RSA
        POPM      PMST
        POPM      BRC
        POPM      ST1
        POPM      ST0
        POPM      T
        POPM      BK
        POPM      FP
        POPM      AR7
        POPM      AR6
        POPM      AR5
        POPM      AR4
        POPM      AR3
        POPM      AR2
        POPM      AR1
        POPM      AR0
        POPM      BG
        POPM      BH
        POPM      BL
        POPM      AG
        POPM      AH
        POPM      AL
        RETE
        ; branch occurs
	.endfunc	113,0e39dffc7h,23


	.sect	".text"
	.global	_SI_interrupt2
	.sym	_SI_interrupt2,_SI_interrupt2, 32, 2, 0
	.func	123

;***************************************************************
;* FUNCTION DEF: _SI_interrupt2                                *
;***************************************************************
_SI_interrupt2:
	.line	2
        NOP
        PSHM      AL
        PSHM      AH
        PSHM      AG
        PSHM      BL
        PSHM      BH
        PSHM      BG
        PSHM      AR0
        PSHM      AR1
        PSHM      AR2
        PSHM      AR3
        PSHM      AR4
        PSHM      AR5
        PSHM      AR6
        PSHM      AR7
        PSHM      FP
        PSHM      BK
        PSHM      T
        PSHM      ST0
        PSHM      ST1
        PSHM      BRC
        PSHM      PMST
        PSHM      RSA
        PSHM      REA
        ANDM      #32063,*(ST1)
        ORM       #16384,*(ST1)
        ANDM      #-4,*(PMST)
        LDM       SP,A
        ANDM      #-2,*(SP)
        NOP
        NOP
        PSHM      AL
        FRAME     #-1
	.line	4
 SSBX INTM
	.line	6
        CALLD     #_brd_led_toggle      ; |128| 
        NOP
        LD        #2,A
        ; call occurs [#_brd_led_toggle] ; |128| 
	.line	35
 STM #5,1h
	.line	36
 STM #1,0h
	.line	37
 RSBX INTM
	.line	38
        FRAME     #1
        POPM      SP
        NOP
        POPM      REA
        POPM      RSA
        POPM      PMST
        POPM      BRC
        POPM      ST1
        POPM      ST0
        POPM      T
        POPM      BK
        POPM      FP
        POPM      AR7
        POPM      AR6
        POPM      AR5
        POPM      AR4
        POPM      AR3
        POPM      AR2
        POPM      AR1
        POPM      AR0
        POPM      BG
        POPM      BH
        POPM      BL
        POPM      AG
        POPM      AH
        POPM      AL
        RETE
        ; branch occurs
	.endfunc	160,0e39dffc7h,23


;***************************************************************
;* UNDEFINED EXTERNAL REFERENCES                               *
;***************************************************************
	.global	_brd_led_enable
	.global	_brd_led_disable
	.global	_brd_led_toggle

;***************************************************************
;* TYPE INFORMATION                                            *
;***************************************************************
	.sym	_s16, 0, 4, 13, 16
	.sym	_u16, 0, 14, 13, 16
	.sym	_u16, 0, 14, 13, 16
	.sym	_word, 0, 14, 13, 16
	.sym	_word, 0, 14, 13, 16
	.etag	$$fake0, 16
	.member	_BRD_LED0, 0, 4, 16, 16
	.member	_BRD_LED1, 1, 4, 16, 16
	.member	_BRD_LED2, 2, 4, 16, 16
	.eos
	.sym	_BrdLed, 0, 10, 13, 16,$$fake0
