/*
 *  Copyright 2001 by Texas Instruments Incorporated.
 *  All rights reserved. Property of Texas Instruments Incorporated.
 *  Restricted rights to use, duplicate or disclose this code are
 *  granted through contract.
 *  
 */
/* "@(#) DSP/BIOS 4.60.22 12-07-01 (barracuda-j15)" */
/***************************************************************************/
/*                                                                         */
/*     H E L L O . C                                                       */
/*                                                                         */
/*     Basic C standard I/O from main.                                     */
/*                                                                         */
/*                                                                         */
/***************************************************************************/

#include <stdio.h>
#define CHIP_5402 1
#include "csl.h"
#include "csl_irq.h"

interrupt void interrupt1();

 
/*  ======== main ========*/
void main()
{
int temp = 0;
if (temp == 0) {
	asm("	SSBX 1, 13");
	temp = 1;
}

asm("	RSBX INTM");
asm("	ORM #0000000000000001b,*(#IMR) ; Unmask the local mask.");
asm("Here: B Here ; Stays here indefinitely...");

}

interrupt void interrupt1()
{
asm("	RSBX 1, 13");
}

